/*
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOUSE. See the GNU
 * General Public License for more details.
 *
 * You should have recieved a copy of the GNU General Public License
 * along with this program; if not write to the Free Software
 * Foundation, inc., 59 Temple Place, Suite 330, Boston MA 02111-1307
 * USA
 */


/**
 *
 * @author Yuriy Mikhaylovskiy
 * @email YuriyMikhaylovskiy@yahoo.com
 * 
 */


import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.util.*;
import java.net.*;
import javax.swing.filechooser.*;

public class _doc extends JMCADObject {
  private final Image img = new ImageIcon(this.getClass().getResource("_doc.gif")).getImage();
  private JTextField tf;
  //private String file_name;
  private URI uri;

  private RandomAccessFile fin;

  public void write(RandomAccessFile fout)  throws IOException{
    fout.writeBytes("["+Id+" = "+this.getClass().getName()+"]\n");
    fout.writeBytes("position = "+getLocation().x+","+getLocation().y+"\n");
    fout.writeBytes("model = "+(uri==null?"":uri)+"\n");
  }
                                                                                                                             
  public void parse(String pst){
      super.parse(pst);
      StringTokenizer stt = new StringTokenizer(pst,"\n");
      while(stt.hasMoreTokens()){
        try{
          String st = stt.nextToken();
          st=st.trim();
          if(st.length()!=0){
            StringTokenizer stt0 = new StringTokenizer(st," =,\t");
            String st0 = stt0.nextToken();
            if(st0.equalsIgnoreCase("MODEL"))  uri = new URI(stt0.nextToken());
          }
        } catch(Exception e1) {error(e1);}
      }
      //try{ init(); } catch(Exception e2) {error(e2);}
      //this.getParent().validate();
      //this.revalidate();
  }

  public _doc() {
    ToolTipText = java.util.ResourceBundle.getBundle("JMCAD_Internationalize").getString("Does_not_work!")+"   ";
    //in = new double[0];
    //in_text = new String[0];
    //out = new double[0];
    //out_text = new String[0];
    //out_obj = new Object[0];
    //out_obj_index = new int[0];
    w = 60;
    h = 36;
    try { init(); }catch(Exception e) { e.printStackTrace(); }
  }
  public void paint_info(Graphics g){
    g.drawImage(img,panel_c.getWidth()/2-18,panel_c.getHeight()/2-18,this);
  }

  public void calc(){
    //out[0]=in[0];
    //in[0]=Double.NaN;
  }
  public void edit_pre(){
    edit_panel = new JPanel(new VerticalFlowLayout());
    tf = new JTextField();
    JPanel p0 = new JPanel(new BorderLayout());                                                                                
    tf.setText(uri==null?"":uri.toString());
    //tf.setEditable(false);
    JButton b = new JButton("...");    
    b.addActionListener(new ActionListener() {
        public void actionPerformed(ActionEvent e) {
            try {
                FileNameExtensionFilter filter = new FileNameExtensionFilter(ResourceBundle.getBundle("JMCAD_Internationalize").getString("Open_JMCAD_model_*.jmcad"), "jmcad");
                JFileChooser fd = new JFileChooser(".");
                fd.addChoosableFileFilter(filter);
                fd.setMultiSelectionEnabled(false);
                int choise = fd.showOpenDialog((Component)e.getSource());
                if(choise == JFileChooser.APPROVE_OPTION){
                    File f = fd.getSelectedFile();
                    if (fd.getFileFilter().equals(filter)) {
                        uri = f.toURI();
                        //file_name=f.toString();//.getPath();
                        if(f!=null){
                            tf.setText(uri.toString());
                        }
                    }
                }
            } catch(Exception e1) {error(e1);}
        }
    });
    p0.add(new JLabel("  "),BorderLayout.NORTH);
    p0.add(tf,BorderLayout.CENTER);
    p0.add(b,BorderLayout.EAST);
    edit_panel.add(p0);
  }
  public void edit_post(){
    try {
      System.out.println("Set URI: "+uri.toString().replace('/', File.separatorChar));
      fin = new RandomAccessFile(uri.toString().replace('/', File.separatorChar),"r");
      String st;
      int countin = 0;
	  int countout = 0;
      while((st=fin.readLine())!=null){
        StringTokenizer stt = new StringTokenizer(st);
		if (st.indexOf("_docin")!=-1){	
              countin++;
              }
		if (st.indexOf("_docout")!=-1){
			countout++;
		}
      }
      fin.close();
      w = 76;
      h = 36;
      in = new double[countin];
      in_text = new String[countin];
      out = new double[countout];
      out_obj = new Object[countout];
      out_obj_index = new int[countout];
     
 for(int i=0; i<countout; i++) out[i] = Double.NaN;
      out_text = new String[countout];
      for(int i=0; i<countout; i++) out_text[i] = "OUT"+i;
for(int i=0; i<countin; i++) in[i] = Double.NaN;
      in_text = new String[countin];
      for(int i=0; i<countin; i++) in_text[i] = "IN"+i;

 try { init(); }catch(Exception e) { e.printStackTrace(); }
      this.getParent().validate();
      this.revalidate();

    }catch(Exception e) { error(e); }
  }
  
 
  }
  






