/*
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOUSE. See the GNU
 * General Public License for more details.
 *
 * You should have recieved a copy of the GNU General Public License
 * along with this program; if not write to the Free Software
 * Foundation, inc., 59 Temple Place, Suite 330, Boston MA 02111-1307
 * USA
 */


/**
 *
 * @author Yuriy Mikhaylovskiy
 * @email YuriyMikhaylovskiy@yahoo.com
 * 
 */


import javax.swing.*;
import java.awt.*;
import java.util.*;
import java.io.*;

public class _progress_bar_h extends JMCADObject{
  public JProgressBar progress_bar = new JProgressBar();
  private JTextField tf0 = new JTextField();
  private JTextField tf1 = new JTextField();
  private int from = 0;
  private int to = 100;

  public void write(RandomAccessFile fout)  throws IOException{
    super.write(fout);
    fout.writeBytes("min = "+from+"\n");
    fout.writeBytes("max = "+to+"\n");
  }

  public void parse(String pst){
    super.parse(pst);

    StringTokenizer stt = new StringTokenizer(pst,"\n");
    while(stt.hasMoreTokens()){
      try{
        String st = stt.nextToken();
        st=st.trim();
        if(st.length()!=0){
          StringTokenizer stt0 = new StringTokenizer(st," =,\t");
          String st0 = stt0.nextToken();
          if(st0.equalsIgnoreCase("MIN")){
            st0 = stt0.nextToken();
            if(!st0.equalsIgnoreCase("NAN"))  try{ from = Integer.parseInt(st0); } catch(Exception e3) {error(e3);}
          }else if(st0.equalsIgnoreCase("MAX")){
            st0 = stt0.nextToken();
            if(!st0.equalsIgnoreCase("NAN"))  try{ to = Integer.parseInt(st0); } catch(Exception e3) {error(e3);}
          }
        }
      } catch(Exception e1) {error(e1);}
    }
    panel_c.removeAll();
    panel_c.setLayout(new BorderLayout());
    panel_c.add(progress_bar,BorderLayout.CENTER);
  }

  public _progress_bar_h() {
    this.isVisual = true;
    ToolTipText = ResourceBundle.getBundle("JMCAD_Internationalize").getString("Progress_Bar");
    in = new double[1];
    in_text = new String[1];
    in[0] = Double.NaN;
    in_text[0] = "IN";
    out = new double[1];
    out[0] = Double.NaN;
    out_text = new String[1];
    out_text[0] = "OUT";
    out_obj = new Object[1];
    out_obj_index = new int[1];
    w = 250;
    h = 25;
    progress_bar.setToolTipText(ToolTipText);
    progress_bar.setMinimum(0);
    progress_bar.setMaximum(100);
    progress_bar.setValue(0);
    progress_bar.setStringPainted(true);
    try { init(); }catch(Exception e) { e.printStackTrace(); }
    panel_c.removeAll();
    panel_c.setLayout(new BorderLayout());
    panel_c.add(progress_bar,BorderLayout.CENTER);
    progress_bar.validate();
  }

  public void calc_pre(){
      progress_bar.setValue((int)from);
      progress_bar.setMinimum((int)from);
      progress_bar.setMaximum((int)to);
  }

  public void calc(){
    out[0]=in[0];
    progress_bar.setValue((int)Math.round(in[0]));
    in[0]=Double.NaN;
  }
  
  public void paint_info(Graphics g){ }

  public void edit_pre(){
    edit_panel = new JPanel(new VerticalFlowLayout());
    tf0.setText(""+from);
    tf1.setText(""+to);
    JPanel p0 = new JPanel(new BorderLayout());
    JPanel p1 = new JPanel(new BorderLayout());
    p0.add(new JLabel(ResourceBundle.getBundle("JMCAD_Internationalize").getString("Minimum_value")),BorderLayout.WEST);
    p0.add(tf0,BorderLayout.CENTER);
    p1.add(new JLabel(ResourceBundle.getBundle("JMCAD_Internationalize").getString("Maximum_value")),BorderLayout.WEST);
    p1.add(tf1,BorderLayout.CENTER);
    edit_panel.add(p0);
    edit_panel.add(p1);
  }

  public void edit_post(){
    try {
      int dfrom = Integer.parseInt(tf0.getText());
      int dto = Integer.parseInt(tf1.getText());
      from = dfrom;
      to = dto;
    }catch(Exception e) { error(e); }
  }

}


